
#include "simpleTokenizer.h"	//For using the static methods of the TokenAnalyzer class
#include "simpleEvaluator.h"	//For using the static methods of the SimpleEvaluator class

#include <iostream>  	// For basic iostream operations
#include <string>  		// For strings

using namespace std;

const int BUFFER_SIZE = 120;
const int MAX_NUMBER_OF_TOKENS = 50;


void main()
{


	while (true)
	{	char inputBuffer[BUFFER_SIZE];

		//Read a infix expression into a character array
		cout << endl << endl << "Give me an infix arithmetic expression:" << endl;
		cin.getline(inputBuffer, BUFFER_SIZE);

		//Call the getTokensFromOneCharArray static method of TokenAnalyzer class to 
		//	analyze and retrieve all the tokens into the tokensOfInfixExpression vector 
		vector<string> tokensOfInfixExpression;
		TokenAnalyzer::getTokensFromOneCharArray(inputBuffer, tokensOfInfixExpression);

		//Display the tokens of the infix expression 
		cout << endl << endl << "Tokens of the infix expression" << endl;
		TokenAnalyzer::displayTokens(tokensOfInfixExpression);

		//infix to postfix conversion
		vector<string> tokensOfPostfixExpression;

		SimpleEvaluator::infixToPostfix(tokensOfInfixExpression, tokensOfPostfixExpression);

		cout << endl << endl << "Tokens of the corresponding postfix expression" << endl;
		TokenAnalyzer::displayTokens(tokensOfPostfixExpression);

		//postfix evaluation
		bool isValidExpression;
		double result;

		isValidExpression = 
		SimpleEvaluator::evaluatePostfixExpression(tokensOfPostfixExpression, result);

		if (isValidExpression)
		{
			cout << endl << endl 
				<< "******************************************" << endl;
			cout << "The value of the expression is " << result << endl
				<< "******************************************" << endl << endl;
		}
		else
		{
			cout << endl << endl 
				<< "******************************************" << endl;
			cout << "An invalid expression!! "  << endl
				<< "******************************************" << endl << endl;
		}
	}

}
