

//If SIMPLE_EVALUATOR_H  is not defined yet, define it here to avoid inclusion
//of simpleEvaluator.h again later during the compilation of the module.
#ifndef SIMPLE_EVALUATOR_H
#define SIMPLE_EVALUATOR_H

#include <vector>
#include <string>
using namespace std;


class SimpleEvaluator
{  public:
	//Given an infix expression tokensOfInfixExpression as a vector strings of (tokens), 
	//	determine the postfix expression tokensOfPostfixExpression as a vector strings of (tokens).
	//If tokensOfInfixExpression is not in proper infix format, and derived tokensOfPostfixExpression
	//	will not be in proer postfix format either. 
	static void infixToPostfix(	const vector<string> & tokensOfInfixExpression, 
								vector<string> & tokensOfPostfixExpression	);

	//Given a postfix expression tokensOfPostfixExpression as a vector strings of (tokens), 
	//	evaluate its value ad store it in result.
	//Return false if tokensOfPostfixExpression is not in proper postfix format, and thus
	//	cannot be evaluated into a valid result;
	//otherwise, return true.
	static bool evaluatePostfixExpression(const	vector<string> & tokensOfPostfixExpression,
												double & result		);

	//****************************************************
	//Get the precedence level of an operator token
	// 1: for + and -
	// 2: for * and /
	// 0: for the others as unknown
	//****************************************************
	static int getPrecedenceLevel(string opToken);

};

#endif