

//If LEXICAL_ANALYSIS_H  not defined yet, define it here to avoid inclusion
//of lexScanner.h again later during the compilation of the module.
#ifndef SIMPLE_SCANNER_H
#define SIMPLE_SCANNER_H

#include <vector>
#include <string>
using namespace std;


class TokenAnalyzer
{  public:
	//***************************************************************************
	//*  Prototype of getTokensFromOneCharArray
	//*
	//***************************************************************************
	//*  This function analyzes a given C-style character array to recognize and
	//*   store the token strings embedded there into an array of strings
	//***************************************************************************
	//***************************************************************************
	// 1. One line of code is stored in a C-style character array: ptrOriginalStatement,
	//    with a terminating '\0' NULL character to end the string stored there.
	// 2. We then store all the tokens, each as a string object of the string class,
	//    into tokenArray, which is a vector of strings.

	static void TokenAnalyzer::getTokensFromOneCharArray
						(
							const char* ptrOriginalStatement,
							vector<string> & tokenVector
						);



	//*************************************************************************
	// Display the tokens (and their categories) in a vetor of tokens (strings)
	//*************************************************************************
	static void TokenAnalyzer::displayTokens(vector<string> tokensOfExpression);


	//****************************************************************************
	// Prototypes of functions to test the category of a given token
	//****************************************************************************
	static	bool isLEFT_PARENTHESIS(const string & token);
	static	bool isRIGHT_PARENTHESIS(const string & token);
	static	bool isNUMERICAL_LITERAL(const string & token);
	static	bool isNUMERICAL_OP(const string & token);
};

#endif